'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = hiddenDataGetterSetter;

var _hiddenData = require('../hiddenData');

function hiddenDataGetterSetter(propName) {
  var get = (0, _hiddenData.createHiddenDataGetter)(propName);
  var set = (0, _hiddenData.createHiddenDataSetter)(propName);

  return function (target, property, descriptor) {
    descriptor.value = function decorator$hiddenDataGetterSetter() {
      if (arguments.length === 0) {
        return get(this);
      } else {
        set(this, arguments[0]);
      }
    };
  };
}